import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * "The Dungeon of Pain" is a game, where You should defeat 5 bosses
 * and to get to those You will need to kill their guardians.
 * Move a character with arrows and click on his skills.
 * Good luck to You not to feel The Pain of a Dungeon!
 * 
 * @authors Tartynskih Pjotr, Shutov Konstantin, Dymov Maxim, Egor Logachjov, Patrushev Eduard
 * @version 0.9
 */
public class Level extends World
{

    /**
     * Placing mobs
     */
    static Actor hero = new Hero();
    static Actor keeper = new Keeper();
    private Mob1 mob1 = new Mob1();
    private Mob2 mob2 = new Mob2();
    private Mob3 mob3 = new Mob3();
    private Mob4 mob4 = new Mob4();
    private Mob5 mob5 = new Mob5();
    private Mob6 mob6 = new Mob6();
    private Mob7 mob7 = new Mob7();
    public Level() 
    {
        super(10, 9, 64);
        removeObjects(getObjects(null));
        AddWalls();
        AddMobs();
        AddBosses();
        addObject(keeper,5,4);
        addObject(hero,4,4);       
        setBackground("Ячейка основного подземелья.jpg");
    }
    public void act()
    {
        if(Hero.HeroHP<=0)
        {
            removeObject(Hero.background);
            removeObject(Hero.dh1);
            removeObject(Hero.dh2);
            removeObject(Hero.dh3);
            removeObject(Hero.dh4);
            removeObject(Hero.dh);
            removeObject(Mobs.bm); 
            hero.setLocation(4, 4);
            DeleteMobs();
            AddMobs();
            Hero.HeroHP=100;
            Hero.HeroEnergy=100;
        }    
        
        ClearWindow();  
    }    

    /**
     * 
     */
    
    public void AddMobs()
    {
       addObject(mob1,1 ,2 ); 
       addObject(mob2,6 ,1 ); 
       addObject(mob3,8 ,3 ); 
       addObject(mob4,7 ,6 ); 
       addObject(mob5,3 ,3 ); 
       addObject(mob6,1 ,7 ); 
       addObject(mob7,2 ,6 );    
    }
    public void DeleteMobs()
    {
        removeObject(mob1);
        removeObject(mob2);
        removeObject(mob3);
        removeObject(mob4);
        removeObject(mob5);
        removeObject(mob6); 
        removeObject(mob7); 
        mob1 = new Mob1();
        mob2 = new Mob2();
        mob3 = new Mob3();
        mob4 = new Mob4();
        mob5 = new Mob5();
        mob6 = new Mob6();
        mob7 = new Mob7();
    }    
    /**
     * Placing bosses
     */
    public void AddBosses()
    {
       addObject(new Boss1(),5 ,2 ); 
       addObject(new Boss2(),6 ,8 ); 
       addObject(new Boss3(),9 ,0 ); 
       addObject(new Boss4(),0 ,5 ); 
       addObject(new Boss5(),0 ,0 );    
    }
    /**
     * Placing walls
     */
    public void AddWalls()
    {
        addObject(new Wall1(),1,1);
        addObject(new Wall1(),1,0);
        addObject(new Wall1(),1,3);
        addObject(new Wall1(),1,4);
        addObject(new Wall1(),1,5);
        addObject(new Wall1(),1,6);
        addObject(new Wall1(),1,8);
        addObject(new Wall2(),0,4);
        addObject(new Wall2(),2,3);
        addObject(new Wall2(),4,3);
        addObject(new Wall2(),5,3);
        addObject(new Wall2(),6,3);
        addObject(new Wall2(),7,3);
        addObject(new Wall2(),9,3);
        addObject(new Wall1(),6,2);
        addObject(new Wall1(),6,0);
        addObject(new Wall2(),9,6);
        addObject(new Wall2(),8,6);
        addObject(new Wall2(),6,6);
        addObject(new Wall2(),5,6);
        addObject(new Wall2(),4,6);
        addObject(new Wall2(),3,6);
        addObject(new Wall1(),5,7);
        addObject(new Wall1(),3,7);
        addObject(new Wall1(),5,8);
        addObject(new Wall1(),8,7);
        addObject(new Wall2(),1,6);
        addObject(new Wall1(),4,2); 
                   
    }
    
    public void ClearWindow()
    {
        showText(" ", 1, 2);
        showText(" ", 4, 2);
        showText(" ", 7, 2);
    }
}