import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Loading animation, made just for cosmetic purpose.
 * 
 * @authors Tartynskih Pjotr, Shutov Konstantin, Dymov Maxim, Egor Logachjov, Patrushev Eduard
 * @version 0.9
 */
public class Loading extends PlayButton
{
    /**
     * Act - do whatever the Loading wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    
    private GifImage gif = new GifImage("loading.gif");
    private int millisElapsed = 0;
    private long lastTime = 0;
    static World world;
    
    public void act() 
    {
        setImage(gif.getCurrentImage());
        
        long time = System.currentTimeMillis();
            
        if(lastTime != 0)
        {
            long diff = time - lastTime;
            millisElapsed += diff;
        }   
        
        lastTime = time;
            
        if (millisElapsed > 1100)
        {
            world = new Level();
            Greenfoot.setWorld(world);
            millisElapsed = 0;
            lastTime = 0;
        }
    }    
}
